program SMTPX ;
{ By Peter Meiring, G0BSX. All rights Reserved.                              }
{ Version 1.02: RFC822 compatible                                            }
{ This is a program will scan the SMTP Queue directory and extract files     }
{ Therein for importation into the mailbox.  It will search for a "callsign" }
{ in the TO field and, if found, will make that message PRIVATE, else it     }
{ will make it a public bulletin                                             }
{ The program requires 2 parameters, namely the Mailbox IMPORT filename and  }
{ the host id of SMTP system Mailbox.                                        }

{ File Format: RQUEUE.WRK }
{ From: user@host           }
{ To: user[%host][@host]    }

{ file format: RQUEUE .TXT file. }
{ Received: from <hostid> by <hostid> with SMTP }
{ 	id AA7750 ; <day>, <date> <time> GMT         }
{ Date: <day>, <date> <time> GMT                }
{ Message-Id: <<number>@<hostid>>               }
{ From: <user>@<hostid> ( name )                }
{ To: <user>%<bbs>@host                         }
{ Subject: Message Title                        }
{                                               }
{ Message TEXT                                  }

{ file format: MAIL files. }
{ From g0bsx@g0bsx.ampr.org Sun Jun 24 19:21:50 1990 }
{ Received: from g0bsx by g0bsx.ampr.org with SMTP   }
{        id AA27765 ; Sun, 24 Jun 90 19:21:49 utc    }
{ Date: Sun, 24 Jun 90 19:23:55 GMT                  }
{ Message-Id: <53@g0bsx.ampr.org>                    }
{ From: g0bsx@g0bsx.ampr.org (Peter Meiring)         }
{ To: g0bsx%mac@g0bsx                                }
{ Subject: test 5                                    }
{                                                    }
{ Message Text.                                      }

{ File Format: MQUEUE .WRK files }
{ host                             }
{ user@host        (source)        }
{ user[%node]@host (destination)   }

const
      Version    = 'Version 2.0 (c) Peter Meiring, G0BSX, June 1990.';
      SMTPDir    = '\SPOOL\MQUEUE\';
      MAILDir    = '\SPOOL\MAIL\';

type WorkString = string[255];
     String40   = string[40];

var CurrentPath : WorkString;
    OutFP : text;
    DelFP : text;

function toUpper( str : WorkString ) : WorkString;

var i : integer;
    t : Workstring;

begin
  t := '';
  for i := 1 to length(str) do
    t := t + UpCase(str[i]);
  ToUpper := t
end;

function Now : String40;

type
  regpack = record
              ax,bx,cx,dx,bp,si,di,ds,es,flags: integer;
            end;

var
  recpack:          regpack;             {assign record}
  ah,al,ch,cl,dh:   byte;
  hour,min,sec,day:     string[2];
  month, year, dow:     string[4];
  dx,cx,m,wd :          integer;

begin
  ah := $2c;                             {initialize correct registers}
  with recpack do
  begin
    ax := ah shl 8 + al;
  end;
  intr($21,recpack);                     {call interrupt}
  with recpack do begin
    str(cx shr 8,hour);                  {convert to string}
    if length(hour) < 2 then hour := '0'+hour;
      str(cx mod 256,min);                       { " }
    if length(min) < 2 then min := '0'+min;
      str(dx shr 8,sec);                         { " }
    if length(sec) < 2 then sec := '0'+sec
  end;
  with recpack do
  begin
    ax := $2a shl 8;
  end;
  MsDos(recpack);                        { call function }
  with recpack do
  begin
    str(cx,year);                        {convert to string}
    str(dx mod 256,day);                     { " }
    m := dx shr 8;
    wd := ax mod 256
  end;
  case m of
    1 : month := 'Jan';
    2 : month := 'Feb';
    3 : month := 'Mar';
    4 : month := 'Apr';
    5 : month := 'May';
    6 : Month := 'Jun';
    7 : month := 'Jul';
    8 : month := 'Aug';
    9 : month := 'Sep';
    10 : month := 'Oct';
    11 : month := 'Nov';
    12 : month := 'Dec'
  end;
  case wd of
    0 : dow := 'Sun';
    1 : dow := 'Mon';
    2 : dow := 'Tue';
    3 : dow := 'Wed';
    4 : dow := 'Thu';
    5 : dow := 'Fri';
    6 : dow := 'Sat'
  end;
  Now := dow +' '+month+' '+day+' '+hour+ ':'+min+':'+sec+' '+year
end;

procedure ProcessDirectory;

type
  Char12arr            = array [ 1..12 ] of Char;
  RegRec =
    record
      AX, BX, CX, DX, BP, SI, DI, DS, ES, Flags : Integer;
    end;

var
  Regs                 : RegRec;
  DTA                  : array [ 1..43 ] of Byte;
  Mask                 : Char12arr;
  NamR                 : String40;
  Error, I             : Integer;
  msgFP                : text;


procedure Process( fname : String40 );

var ToCall, AtCall, HostCall, TextFilename, LockFilename : String40;
    ToLine, FrmLine, Xmsgtype : String40 ;
    ss : WorkString;
    InFP : text;
    Bull : boolean;
    l, T1, T2, T3 : integer;

function IsCall( name : String40 ) : boolean;

var n : integer;
    f,f1,f2,f3,f4 : boolean;

function IsAlpha( c : char ) : boolean;
begin
  if ((c <= 'Z') and (c >= 'A')) or ((c <= 'z') and (c >= 'a')) then
    IsAlpha := TRUE
  else
    IsAlpha := FALSE
end;

function IsNumber( c : char ) : boolean;
begin
  if (c >= '0') and (c <= '9') then
    IsNumber := TRUE
  else
    IsNumber := FALSE
end;

begin
  f := (length(name) > 2);
  f1 := IsAlpha(name[1]) and IsNumber(name[2]) and IsAlpha(name[3]);
  f2 := IsAlpha(name[1]) and IsNumber(name[2]) and IsNumber(name[3])
        and IsAlpha(name[4]);
  f3 := IsAlpha(name[1])  and IsAlpha(name[2]) and IsNumber(name[3])
        and IsAlpha(name[4]);
  f4 := IsNumber(name[1]) and IsAlpha(name[2]) and IsNumber(name[3])
       and IsAlpha(name[4]);
  IsCall := f and (f1 or f2 or f3 or f4)
end;

function Deliverable( fs   : String40;
                      ts   : String40;
                      host : String40;
                      user : String40;
                      txtfname : String40;
                      T    : Integer      ) : boolean ;

var    hs, us : String40;
       s      : WorkString;
       delivered : boolean ;


procedure mqueue(hst, src, dst : String40);

var fp, lfp, tfp : text ;
    n : integer;
    fname : String40;
    line : WorkString;

begin
  assign(fp, SMTPDir + 'SEQUENCE.SEQ');
{$I-}
  reset(fp);
  if IOResult <> 0 then
    n := 0
  else
    read(fp,n);
  n := Succ(n);
  rewrite(fp);
{I+}
  writeln(fp,n);
  close(fp);
  Writeln('  SMTP msg: ',n,' to ',dst,' at ',hst,' from ',src);
  str(n, fname);
  assign(lfp, SMTPDir + fname + '.LCK');
  rewrite(lfp);
  assign( fp, SMTPDir + fname + '.WRK');
  rewrite(fp);
  writeln(fp, hst);
  writeln(fp, src);
  writeln(fp, dst);
  close(fp);
  assign(fp, SMTPDir + fname + '.TXT');
  rewrite(fp);
  assign(tfp, txtfname);
  reset(tfp);
  repeat
    readln(tfp, line);
    writeln(fp, line)
  until eof(tfp);
  close(fp);
  erase(tfp);
  erase(lfp)
end;

procedure mail( uname, frm: String40 );

var fp,tfp : text;
    Line   : WorkString;

begin
  writeln('Appending to '+MAILDir+uname+'.TXT');
   {$I-}
  assign(fp, MAILDir+uname+'.TXT');
  append(fp);
  if IOResult <> 0 then
    rewrite(fp);
{$I+}
  writeln(fp);
  writeln(fp, 'From '+frm+' '+Now);
  assign(tfp, TxtFname);
  reset(tfp);
  while not eof(tfp) do begin
    readln(tfp, Line);
    writeln(fp, Line)
  end;
  close(fp);
  erase(tfp)
end;

begin
{$I-}
  reset(DelFP);
  if IOResult <> 0 then begin
    writeln('*** Error in resetting ', ParamStr(2));
    close(DelFP);
    close(OutFP);
    halt
  end;
  writeln('Delivery condition file: ',ParamStr(2),' open.');
{$I+}
  delivered := false;
  while (not eof(DelFP)) do begin
    readln(DelFP, s);
    writeln('Destination: ',s);
    if (pos('host', s) > 0) and (pos(Paramstr(4), s) = 0) then
      if pos(host, s) > 0 then begin
         mqueue( host, fs, ts);
         delivered := true
      end;
    if (T = 0) and (pos('user', s) > 0) then
      if pos(user, s) > 0 then begin
         readln( DelFP, hs);
         readln( DelFP, us);
         mqueue( hs, fs, us);
         delivered := true
      end;
    if (T = 0) and (pos('mail', s) > 0) then
      if pos(user, s) > 0 then begin
        mail(user, fs);
        delivered := true
      end
  end;
  Deliverable := delivered
end;


begin
  LockFilename := copy( fname, 1, pos('.', fname)) + 'LCK';
  TextFilename := copy( fname, 1, pos('.', fname)) + 'TXT';
  assign( InFP, LockFilename);
  {$I-}
  reset(InFP);
  if IOResult = 0 then begin
    writeln( ' locked by SMTP');
    close(InFP)
  {$I+}
  end else begin
    assign(InFP, fname);
    reset(InFP);
    readln(InFP,FrmLine);
    readln(InFP, ToLine);
    close(InFP);
    writeln(fname,'  ',FrmLine,'  ',ToLine);
    T1 := pos(' ',ToLine) + 1;
    T2 := pos('%',ToLine);
    T3 := pos('@',ToLine);
    If (T2 = 0) then begin
      if T3 = 0 then
          ToCall := copy(ToLine,T1,length(ToLine)-T1+1)
      else
          ToCall := copy(ToLine,T1,T3-T1);
      AtCall := ParamStr(3)
    end
    else begin
       if T3 > 0 then
         AtCall := Copy(ToLine, T2+1, T3-T2)
       else
         AtCall := Copy(ToLine, T2+1, Length(ToLine)-T2);
       ToCall := Copy(ToLine, T1, T2-T1)
    end;
    if T3 = 0 then
      Hostcall := Paramstr(4)
    else
      Hostcall := copy(ToLine, T3+1, length(ToLine)-T3);
    if not Deliverable( copy(Frmline, 7, length(Frmline)-5),
                        copy(ToLine, 5, length(ToLine)-3),
                        hostcall, ToCall, Textfilename, T2) then begin
      Xmsgtype := 'X-msgtype: ';
      if IsCall( ToCall ) then
        Xmsgtype := Xmsgtype + 'P'
      else
        Xmsgtype := Xmsgtype + 'B';
      close( Infp);
      assign( InFP, Textfilename);
      reset( InFP );
      ToCall := toupper(ToCall);
      AtCall := toupper(AtCall);
      repeat
         readln( InFP, ss );
         if pos('To:', ss) > 0 then begin
           writeln(OutFP, 'To: ',ToCall,'@',AtCall);
           writeln(OutFP, Xmsgtype);
         end else
           writeln(OutFP,ss);
      until ss = '' ;
      writeln(OutFP);
      Writeln(OutFP, '> G0BSX SMTP->MBX Server.');
      reset(InFP);
      repeat
        readln(InFP,ss);
        if pos('Received:', ss) >0 then begin
          writeln(OutFP,ss);
          readln(InFP,ss);
          Writeln(OutFP,ss);
        end;
        if pos('Date:', ss)>0 then
          Writeln(OutFP, ss)
      until ss = '';
      writeln(outFP, ss);
      while not EOF(InFP) do begin
        readln(InFP,ss);
        writeln(OutFP,ss)
      end;
      Writeln(OutFP);
      Writeln(OutFP,'/EX');
      close(InFP);
      erase(InFP)
    end
  end;
  assign(InFP,fname);
  erase(InFP)
end;


begin
  FillChar(DTA,SizeOf(DTA),0);        { Initialize the DTA buffer }
  FillChar(Mask,SizeOf(Mask),0);      { Initialize the mask }
  FillChar(NamR,SizeOf(NamR),0);      { Initialize the file name }

  Regs.AX := $1A00;         { Function used to set the DTA }
  Regs.DS := Seg(DTA);      { store the parameter segment in DS }
  Regs.DX := Ofs(DTA);      {   "    "      "     offset in DX }
  MSDos(Regs);              { Set DTA location }
  Error := 0;
  Mask := '????????.???';    { Use message ONLY search }
  Regs.AX := $4E00;          { Get first directory entry }
  Regs.DS := Seg(Mask);      { Point to the file Mask }
  Regs.DX := Ofs(Mask);
  Regs.CX := 22;             { Store the option }
  MSDos(Regs);               { Execute MSDos call }
  Error := Regs.AX and $FF;  { Get Error return }
  I := 1;                    { initialize 'I' to the first element }
  if (Error = 0) then
    repeat
      NamR[I] := Chr(Mem[Seg(DTA):Ofs(DTA)+29+I]);
      I := I + 1;
    until not (NamR[I-1] in [' '..'~']) or (I>20);

  NamR[0] := Chr(I-1);          { set string length because assigning }
                                { by element does not set length }
  while (Error = 0) do begin
    Error := 0;
    Regs.AX := $4F00;           { Function used to get the next }
                                { directory entry }
    Regs.CX := 22;              { Set the file option }
    MSDos( Regs );              { Call MSDos }
    Error := Regs.AX and $FF;   { get the Error return }
    I := 1;
    repeat
      NamR[I] := Chr(Mem[Seg(DTA):Ofs(DTA)+29+I]);
      I := I + 1;
    until not (NamR[I-1] in [' '..'~'] ) or (I > 20);
    NamR[0] := Chr(I-1);
    if (error = 0) and (pos('WRK', NamR) > 0) then
      Process(NamR)
  end;
  writeln;
  writeln('*** Done.')
end;

begin
  writeln('G0BSX  SMTP -> Mailbox General Purpose Server.');
  writeln(Version);
  if ParamCount < 4 then begin
    Writeln( '*** Not enough Parameters');
    Writeln( 'SMTPX usage: SMTPX importfilename deliveryfilename mbscall hostid');
    halt
  end;
  GetDIR(0,CurrentPath);
  {$I-}
  assign(OutFP,ParamStr(1));
  append(OutFP);
  if IOResult <> 0 then begin
     rewrite(OutFP);
     if IOResult <> 0 then begin
       writeln('*** Error in opening ', ParamStr(1));
       close(OutFP);
       halt
     end
  end;
  assign(DelFP,ParamStr(2));
  reset(DelFP);
  if IOResult <> 0 then begin
    writeln('*** Error in opening ', ParamStr(2));
    close(DelFP);
    close(OutFP);
    halt
  end;
  writeln('Delivery condition file: ',ParamStr(2),' open.');
  {$I+}
  writeln( 'Output file open :', ParamStr(1));
  ChDIR('\SPOOL\RQUEUE');
  writeln( 'Current Directory : \SPOOL\RQUEUE');
  ProcessDirectory;
  ChDIR(CurrentPath);
  writeln('Current Directory : ',CurrentPath);
  close( OutFP );
  close( DelFP )
end.